<script setup lang="ts">
import { SequenceMatcher } from "../../difflib/src/sequenceMatcher";
const props = defineProps({
  isJa2Zh: Boolean,
});
const isSelecting = ref(true);
const isWritingOriginal = ref(false);
const isWritingTranslation = ref(false);
const isWaitingDeepL = ref(false);
const isGotDeepL = ref(false);

const isShowMyTrans = ref(false);
const isShowDeepL = ref(false);
const isComparingTrans = ref(true);

const oriLong = ref(false);
const transLong = ref(false);

const langClass = props.isJa2Zh ? "is-lang-ja" : "is-lang-zh";

const themes = [
  "自由記述",
  "先生にお礼の手紙",
  "猫と犬、どっちが好き？",
  "自分と語学について",
  "機械翻訳と翻訳の未来",
];
const selectedTheme = ref(themes[0]);

const placeholder = props.isJa2Zh
  ? "言いたいことを日本語で書いてください"
  : "请用中文填入要表述的内容";

const placeholder2 = props.isJa2Zh
  ? "上記の日本語を中国語に翻訳してください"
  : "请将上述中文翻译成日文";
const { original, update } = useMyText();
const mytext = ref("");
const mytranslation = ref("");
const deepl = ref("");

const mytext2 = ref("");
const deepl2 = ref("");

// onMounted(() => {
//   update(mytext.value);
// });

const selected = () => {
  if (selectedTheme.value !== "") {
    isSelecting.value = false;
    isWritingOriginal.value = true;
  }
};

const writeOriginalDone = () => {
  if (mytext.value.length <= 500) {
    oriLong.value = false;
    mytranslation.value = mytext.value;
    isWritingOriginal.value = false;
    isWritingTranslation.value = true;
  } else {
    oriLong.value = true;
  }
};

const requestDeepL = () => {
  isWaitingDeepL.value = true;
  const query = {
    text: mytext.value,
    src_lang: props.isJa2Zh ? "JA" : "ZH",
    tgt_lang: props.isJa2Zh ? "ZH" : "JA",
  };
  fetch("/api/getMt", { method: "POST", body: JSON.stringify(query) })
    .then((res) => {
      res.text().then((data) => {
        deepl.value = data;
        scrollTo({ top: 0 });
        compareWithDeepL();
      });
    })
    .catch((err) => {
      console.log(err);
    });
};

const compareWithDeepL = () => {
  const sm = new SequenceMatcher();
  sm.setSeqs(mytranslation.value, deepl.value);
  const optext = sm.applyOpcodes(false);
  mytext2.value = optext.replace(/\<ins\>.*?\<\/ins\>/g, "");
  deepl2.value = optext.replace(/\<del\>.*?\<\/del\>/g, "");
  isWritingTranslation.value = false;
  isWaitingDeepL.value = false;
  isGotDeepL.value = true;
};

const toggleMode = (mode: "my" | "deepl" | "compare") => {
  switch (mode) {
    case "my":
      isShowMyTrans.value = true;
      isShowDeepL.value = false;
      isComparingTrans.value = false;
      break;

    case "deepl":
      isShowMyTrans.value = false;
      isShowDeepL.value = true;
      isComparingTrans.value = false;
      break;

    case "compare":
      isShowMyTrans.value = false;
      isShowDeepL.value = false;
      isComparingTrans.value = true;
      break;

    default:
      break;
  }
};

const changing = () => {
  update(mytext.value);
};
</script>

<template>
  <div class="container">
    <section v-if="isSelecting">
      <nav class="level">
        <div class="level-left">
          <div class="level-item">
            <select class="theme-selector" v-model="selectedTheme">
              <option v-for="(theme, thx) in themes" :key="'theme-' + thx">
                {{ theme }}
              </option>
            </select>
          </div>
          <div class="level-item">
            <button class="button is-primary" @click="selected">
              この内容で書く
            </button>
          </div>
        </div>
      </nav>
    </section>
    <section v-if="!isSelecting && !isGotDeepL">
      <h2 class="title is-2 has-text-centered">{{ selectedTheme }}</h2>
      <h3 class="title is-3" :class="langClass" v-if="isWritingOriginal">
        {{ placeholder }}
      </h3>
      <h3 class="title is-3" :class="langClass" v-if="isWritingTranslation">
        {{ placeholder2 }}
      </h3>
      <div class="columns">
        <div
          class="column"
          :class="{
            'is-full': isWritingOriginal,
            'is-half': isWritingTranslation,
          }"
        >
          <textarea
            cols="30"
            rows="10"
            class="textarea is-large"
            :class="{ 'is-primary': isWritingOriginal }"
            v-model="mytext"
            :readonly="isWritingTranslation"
          ></textarea>
          <p class="help" :class="{ 'is-danger': oriLong }">500文字以内</p>
        </div>
        <div class="column is-half" v-if="isWritingTranslation">
          <textarea
            cols="30"
            rows="10"
            class="textarea is-large"
            :class="{ 'is-primary': isWritingTranslation }"
            v-model="mytranslation"
          ></textarea>
        </div>
      </div>
      <button
        class="button is-fullwidth is-primary mt-3"
        @click="writeOriginalDone"
        v-if="isWritingOriginal"
      >
        原文ＯＫ
      </button>
      <div class="notification is-danger has-text-centered mt-3" v-if="oriLong">
        <p>500文字以内でお願いします</p>
      </div>
      <button
        class="button is-fullwidth is-primary mt-3"
        @click="requestDeepL"
        v-if="isWritingTranslation && !isWaitingDeepL"
      >
        翻訳ＯＫ
      </button>
      <button
        class="button is-fullwidth is-primary mt-3 is-loading"
        v-if="isWaitingDeepL"
      ></button>
    </section>

    <section v-if="isGotDeepL">
      <h3 class="title is-3">比較結果を確認しましょう</h3>
      <div class="box">
        <div class="tabs is-toggle">
          <ul>
            <li
              :class="{ 'is-active': isShowMyTrans }"
              @click="toggleMode('my')"
            >
              <a>
                <span>自分の翻訳</span>
              </a>
            </li>
            <li
              :class="{ 'is-active': isShowDeepL }"
              @click="toggleMode('deepl')"
            >
              <a>
                <span>DeepLの翻訳</span>
              </a>
            </li>
            <li
              :class="{ 'is-active': isComparingTrans }"
              @click="toggleMode('compare')"
            >
              <a>
                <span>比較</span>
              </a>
            </li>
          </ul>
        </div>

        <div class="columns" v-if="isShowMyTrans">
          <div class="column is-full">
            <div class="box content m-2">
              <p>{{ mytranslation }}</p>
            </div>
          </div>
        </div>
        <div class="columns" v-if="isShowDeepL">
          <div class="column is-full">
            <div class="box content m-2">
              <p>{{ deepl }}</p>
            </div>
          </div>
        </div>
        <div class="columns" v-if="isComparingTrans">
          <div class="column is-half">
            <div class="box content m-2">
              <p v-html="mytext2" />
            </div>
          </div>
          <div class="column is-half">
            <div class="box content m-2">
              <p v-html="deepl2" />
            </div>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<style scoped lang="scss">
.theme-selector {
  font-size: 1rem;
  margin: 1em auto;
  padding: 0.5rem;
  position: relative;
}
</style>